#include <windows.h>
#include <stdio.h>
#include "shoehorn_dll.h"

#ifdef __cplusplus
extern "C" {
#endif
extern void (*shoehorn_start_callback)(void);

extern void shoehorn_cancel(void);
extern int shoehorn_main(int,char**);

extern void register_message_func(void *func);
extern void register_messagebox_func(void *func);
extern void deregister_message_func(void);
extern void deregister_messagebox_func(void);
#ifdef __cplusplus
}
#endif

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

EXPORT int ShoehornStart(char *port, char *target,
						 char *hermit, char *loader,
						 char *initfile, char *postfile){
	char optbuf[9][256];
	char *opt[9] = {
		optbuf[0], optbuf[1], optbuf[2], optbuf[3],
		optbuf[4], optbuf[5], optbuf[6], optbuf[7],
		optbuf[8]
	};

	if(port == NULL || hermit == NULL ||
		loader == NULL || initfile == NULL ||
		postfile == NULL) return -1;

	sprintf(optbuf[0], "shoehorn");
	sprintf(optbuf[1], "--boot");
	sprintf(optbuf[2], "--terminal");
	sprintf(optbuf[3], "--port=%s", port);
	sprintf(optbuf[4], "--kernel=%s", hermit);
	sprintf(optbuf[5], "--loader=%s", loader);
	sprintf(optbuf[6], "--initfile=%s", initfile);
	sprintf(optbuf[7], "--postfile=%s", postfile);
	sprintf(optbuf[8], "--target=%s", target);

	return shoehorn_main(9,(char **)opt);
}

EXPORT void ShoehornCancel(void){
	shoehorn_cancel();
}

EXPORT void RegisterFunc_Message(void *func){
	register_message_func(func);
}

EXPORT void RegisterFunc_MessageBox(void *func){
	register_messagebox_func(func);
}

EXPORT void DeregisterFunc_Message(void){
	deregister_message_func();
}

EXPORT void DeregisterFunc_MessageBox(void){
	deregister_messagebox_func();
}

EXPORT void RegisterFunc_Start(void *func){
	shoehorn_start_callback = (void (*)(void))func;
}

EXPORT void DeregisterFunc_Start(void){
	shoehorn_start_callback = (void (*)(void))NULL;
}

EXPORT char *DllVersion(void){
	return SHOEHORN_DLL_VERSION;
}
